function solver_v4hingebis = solver_v4hingebis(y)

global a_1 b_1 c_1 d_1 e_1 f_1 g_1 h_1 a_2 b_2 c_2 d_2 e_2 f_2 g_2 h_2 a_3 b_3 c_3 d_3 e_3 f_3 g_3 h_3...
    Pn_1 Pn_2 Pn_3 Material_E J_1 J_2 J_3 dJ_1 dJ_2 dJ_3 d2J_1 d2J_2 d2J_3...
    s_1 ds_1 ds_2 ds_3 R_s_1 R_s_2 R_s_3 dR_s_1 dR_s_2 dR_s_3 d2R_s_1 d2R_s_2 d2R_s_3 d3R_s_1 d3R_s_2 d3R_s_3 d4R_s_1 d4R_s_2 d4R_s_3...
    NP_1 NP_2 NP_3 HP1 HP2 HP3 AL x_s_1...
    aM_1 bM_1 cM_1 dM_1 aM_2 bM_2 cM_2 dM_2 aM_3 bM_3 cM_3 dM_3...
    aT_1 bT_1 cT_1 dT_1 eT_1 aT_2 bT_2 cT_2 dT_2 eT_2 aT_3 bT_3 cT_3 dT_3 eT_3...
    aN_1 bN_1 cN_1 dN_1 eN_1 fN_1 aN_2 bN_2 cN_2 dN_2 eN_2 fN_2 aN_3 bN_3 cN_3 dN_3 eN_3 fN_3...
    k_el k_el_1
    %     d1_1 e1_1 f1_1 g1_1 c2_1 d2_1 e2_1 f2_1 g2_1 b3_1 c3_1 d3_1 e3_1 f3_1 g3_1...
    %     d1_2 e1_2 f1_2 g1_2 c2_2 d2_2 e2_2 f2_2 g2_2 b3_2 c3_2 d3_2 e3_2 f3_2 g3_2...
    %     d1_3 e1_3 f1_3 g1_3 c2_3 d2_3 e2_3 f2_3 g2_3 b3_3 c3_3 d3_3 e3_3 f3_3 g3_3...
    %     m_load_1 m_load_2 m_load_3 s_1 s_2 s_3 s_1_exp s_2_exp s_3_exp
   

%     k_el_1 = (2.1*10^8*J_1(2)/x_s_1(2))*0.1;
%     k_el = (2.1*10^8*J_1(8)/s_1(8));

      k_el = (2.1*10^8*J_1(8)/(x_s_1(8)));
      k_el_1 =  0.2*(2.1*10^8*J_1(8)/(0.5*AL));

%% Definition equation for finite difference

% Inner points:  %derivate dello spostamento espresse rispetto allo
% spostamento stesso

% allocazione memoria
    y1 = zeros(1,71);
    y2 = zeros(1,71);
    y3 = zeros(1,71);
    y4 = zeros(1,71);
    y5 = zeros(1,71);
    y6 = zeros(1,71);

for i=4:NP_1+3
    y1(i) = ((-1/60)*y(i-3) + (3/20)*y(i-2) + (-3/4)*y(i-1) + (0)*y(i) + (3/4)*y(i+1) + (-3/20)*y(i+2) + (1/60)*y(i+3))/ds_1;
    y2(i) = ((1/90)*y(i-3) + (-3/20)*y(i-2) + (3/2)*y(i-1) + (-49/18)*y(i) + (3/2)*y(i+1) + (-3/20)*y(i+2) + (1/90)*y(i+3))/(ds_1^2);
    y3(i) = ((1/8)*y(i-3) + (-1)*y(i-2) + (13/8)*y(i-1) + (0)*y(i) + (-13/8)*y(i+1) + (1)*y(i+2) + (-1/8)*y(i+3))/(ds_1^3);
    y4(i) = ((-1/6)*y(i-3) + (2)*y(i-2) + (-13/2)*y(i-1) + (28/3)*y(i) + (-13/2)*y(i+1) + (2)*y(i+2) + (-1/6)*y(i+3))/(ds_1^4);
    y5(i) = ((-1/2)*y(i-3) + (2)*y(i-2) + (-5/2)*y(i-1) + (0)*y(i) + (5/2)*y(i+1) + (-2)*y(i+2) + (1/2)*y(i+3))/(ds_1^5);
    y6(i) = ((1)*y(i-3) + (-6)*y(i-2) + (15)*y(i-1) + (-20)*y(i) + (15)*y(i+1) + (-6)*y(i+2) + (1)*y(i+3))/(ds_1^6);
end
    y1 = [y1 zeros(1,6)];
    y2 = [y2 zeros(1,6)];
    y3 = [y3 zeros(1,6)];
    y4 = [y4 zeros(1,6)];
    y5 = [y5 zeros(1,6)];
    y6 = [y6 zeros(1,6)];

for i=4:NP_3+3
    y1(i+HP1) = ((-1/60)*y(i+HP1-3) + (3/20)*y(i+HP1-2) + (-3/4)*y(i+HP1-1) + (0)*y(i+HP1) + (3/4)*y(i+HP1+1) + (-3/20)*y(i+HP1+2) + (1/60)*y(i+HP1+3))/ds_3;
    y2(i+HP1) = ((1/90)*y(i+HP1-3) + (-3/20)*y(i+HP1-2) + (3/2)*y(i+HP1-1) + (-49/18)*y(i+HP1) + (3/2)*y(i+HP1+1) + (-3/20)*y(i+HP1+2) + (1/90)*y(i+HP1+3))/(ds_3^2);
    y3(i+HP1) = ((1/8)*y(i+HP1-3) + (-1)*y(i+HP1-2) + (13/8)*y(i+HP1-1) + (0)*y(i+HP1) + (-13/8)*y(i+HP1+1) + (1)*y(i+HP1+2) + (-1/8)*y(i+HP1+3))/(ds_3^3);
    y4(i+HP1) = ((-1/6)*y(i+HP1-3) + (2)*y(i+HP1-2) + (-13/2)*y(i+HP1-1) + (28/3)*y(i+HP1) + (-13/2)*y(i+HP1+1) + (2)*y(i+HP1+2) + (-1/6)*y(i+HP1+3))/(ds_3^4);
    y5(i+HP1) = ((-1/2)*y(i+HP1-3) + (2)*y(i+HP1-2) + (-5/2)*y(i+HP1-1) + (0)*y(i+HP1) + (5/2)*y(i+HP1+1) + (-2)*y(i+HP1+2) + (1/2)*y(i+HP1+3))/(ds_3^5);
    y6(i+HP1) = ((1)*y(i+HP1-3) + (-6)*y(i+HP1-2) + (15)*y(i+HP1-1) + (-20)*y(i+HP1) + (15)*y(i+HP1+1) + (-6)*y(i+HP1+2) + (1)*y(i+HP1+3))/(ds_3^6);
end
    y1 = [y1 zeros(1,6)];
    y2 = [y2 zeros(1,6)];
    y3 = [y3 zeros(1,6)];
    y4 = [y4 zeros(1,6)];
    y5 = [y5 zeros(1,6)];
    y6 = [y6 zeros(1,6)];

for i=4:NP_2+3
    y1(i+HP2) = ((-1/60)*y(i+HP2-3) + (3/20)*y(i+HP2-2) + (-3/4)*y(i+HP2-1) + (0)*y(i+HP2) + (3/4)*y(i+HP2+1) + (-3/20)*y(i+HP2+2) + (1/60)*y(i+HP2+3))/ds_2;
    y2(i+HP2) = ((1/90)*y(i+HP2-3) + (-3/20)*y(i+HP2-2) + (3/2)*y(i+HP2-1) + (-49/18)*y(i+HP2) + (3/2)*y(i+HP2+1) + (-3/20)*y(i+HP2+2) + (1/90)*y(i+HP2+3))/(ds_2^2);
    y3(i+HP2) = ((1/8)*y(i+HP2-3) + (-1)*y(i+HP2-2) + (13/8)*y(i+HP2-1) + (0)*y(i+HP2) + (-13/8)*y(i+HP2+1) + (1)*y(i+HP2+2) + (-1/8)*y(i+HP2+3))/(ds_2^3);
    y4(i+HP2) = ((-1/6)*y(i+HP2-3) + (2)*y(i+HP2-2) + (-13/2)*y(i+HP2-1) + (28/3)*y(i+HP2) + (-13/2)*y(i+HP2+1) + (2)*y(i+HP2+2) + (-1/6)*y(i+HP2+3))/(ds_2^4);
    y5(i+HP2) = ((-1/2)*y(i+HP2-3) + (2)*y(i+HP2-2) + (-5/2)*y(i+HP2-1) + (0)*y(i+HP2) + (5/2)*y(i+HP2+1) + (-2)*y(i+HP2+2) + (1/2)*y(i+HP2+3))/(ds_2^5);
    y6(i+HP2) = ((1)*y(i+HP2-3) + (-6)*y(i+HP2-2) + (15)*y(i+HP2-1) + (-20)*y(i+HP2) + (15)*y(i+HP2+1) + (-6)*y(i+HP2+2) + (1)*y(i+HP2+3))/(ds_2^6);
end

    y1 = [y1 zeros(1,3)];
    y2 = [y2 zeros(1,3)];
    y3 = [y3 zeros(1,3)];
    y4 = [y4 zeros(1,3)];
    y5 = [y5 zeros(1,3)];
    y6 = [y6 zeros(1,3)];

 %% Arco a 4 cerniere 

bc_left = [y(4) y1(4)];
bc_right = [y(HP3-3) y1(HP3-3)];
Equal_u_13 = y(NP_1+3) - y(HP1+4);
Equal_v_13 = -y1(NP_1+3)*R_s_1(NP_1) + y1(HP1+4)*R_s_3(1);
Equal_u_32 = y(HP2-3) - y(HP2+4);
Equal_v_32 = -y1(HP2-3)*R_s_3(NP_3) + y1(HP2+4)*R_s_2(1);
% 
%  %% Cerniere elastiche alla base
% 
M_elhinge_sx = (Material_E.*J_1(1).*(aM_1(1).*y3(4) + bM_1(1).*y2(4) + cM_1(1).*y1(4) + dM_1(1).*y(4)))-...
    (y2(4).*R_s_1(1) + y1(4).*dR_s_1(1) + y(4).*R_s_1(1)).*k_el_1;

M_elhinge_dx = -(Material_E.*J_2(NP_2).*(aM_2(NP_2).*y3(HP3-3) + bM_2(NP_2).*y2(HP3-3) + cM_2(NP_2).*y1(HP3-3) + dM_2(NP_2).*y(HP3-3)))-...
    (y2(HP3-3).*R_s_2(NP_2) + y1(HP3-3).*dR_s_2(NP_2) + y(HP3-3).*R_s_2(NP_2)).*k_el_1;
% 
% 
% %% Condizioni momento cerniere elastiche intermedie
% 
M_elhinge_1 = (Material_E.*J_1(NP_1).*(aM_1(NP_1).*y3(NP_1+3) + bM_1(NP_1).*y2(NP_1+3) + cM_1(NP_1).*y1(NP_1+3) + dM_1(NP_1).*y(NP_1+3)))-...
    ((y2(HP1+4).*R_s_3(1) + y1(HP1+4).*dR_s_3(1) + y(HP1+4).*R_s_3(1))-...
    (y2(NP_1+3).*R_s_1(NP_1) + y1(NP_1+3).*dR_s_1(NP_1) + y(NP_1+3).*R_s_1(NP_1))).*k_el;

M_elhinge_3_sx = (Material_E.*J_3(1).*(aM_3(1).*y3(HP1+4) + bM_3(1).*y2(HP1+4) + cM_3(1).*y1(HP1+4) + dM_3(1).*y(HP1+4)))-...
    ((y2(HP1+4).*R_s_3(1) + y1(HP1+4).*dR_s_3(1) + y(HP1+4).*R_s_3(1))-...
    (y2(NP_1+3).*R_s_1(NP_1) + y1(NP_1+3).*dR_s_1(NP_1) + y(NP_1+3).*R_s_1(NP_1))).*k_el;

M_elhinge_3_dx = -(Material_E.*J_3(NP_3).*(aM_3(NP_3).*y3(HP2-3) + bM_3(NP_3).*y2(HP2-3) + cM_3(NP_3).*y1(HP2-3) + dM_3(NP_3).*y(HP2-3)))+...
    ((y2(HP2+4).*R_s_2(1) + y1(HP2+4).*dR_s_2(1) + y(HP2+4).*R_s_2(1))-...
    (y2(HP2-3).*R_s_3(NP_3) + y1(HP2-3).*dR_s_3(NP_3) + y(HP2-3).*R_s_3(NP_3))).*k_el;

M_elhinge_2 = -(Material_E.*J_2(1).*(aM_2(1).*y3(HP2+4) + bM_2(1).*y2(HP2+4) + cM_2(1).*y1(HP2+4) + dM_2(1).*y(HP2+4)))+...
    ((y2(HP2+4).*R_s_2(1) + y1(HP2+4).*dR_s_2(1) + y(HP2+4).*R_s_2(1))-...
    (y2(HP2-3).*R_s_3(NP_3) + y1(HP2-3).*dR_s_3(NP_3) + y(HP2-3).*R_s_3(NP_3))).*k_el;

% Condizioni momento cerniere totali intermedie
M_1 = Material_E.*J_1(NP_1).*(aM_1(NP_1).*y3(NP_1+3) + bM_1(NP_1).*y2(NP_1+3) + cM_1(NP_1).*y1(NP_1+3) + dM_1(NP_1).*y(NP_1+3));
M_3_sx = Material_E.*J_3(1).*(aM_3(1).*y3(HP1+4) + bM_3(1).*y2(HP1+4) + cM_3(1).*y1(HP1+4) + dM_3(1).*y(HP1+4));

Equal_M_13 = M_1 - M_3_sx;

M_3_dx = Material_E.*J_3(NP_3).*(aM_3(NP_3).*y3(HP2-3) + bM_3(NP_3).*y2(HP2-3) + cM_3(NP_3).*y1(HP2-3) + dM_3(NP_3).*y(HP2-3));
M_2 = Material_E.*J_2(1).*(aM_2(1).*y3(HP2+4) + bM_2(1).*y2(HP2+4) + cM_2(1).*y1(HP2+4) + dM_2(1).*y(HP2+4));

Equal_M_32 = M_3_dx - M_2;
 %% Condizioni al contorno per taglio e sforzo normale definite per sezione costante lungo s 
 
T_1 = -Material_E.*(aT_1(NP_1).*y4(NP_1+3) + bT_1(NP_1).*y3(NP_1+3) + cT_1(NP_1).*y2(NP_1+3) + dT_1(NP_1).*y1(NP_1+3) + eT_1(NP_1).*y(NP_1+3));
T_3_sx = -Material_E.*(aT_3(1).*y4(HP1+4) + bT_3(1).*y3(HP1+4) + cT_3(1).*y2(HP1+4) + dT_3(1).*y1(HP1+4) + eT_3(1).*y(HP1+4));

Equal_T_13 = T_1 - T_3_sx;

T_3_dx = -Material_E.*(aT_3(NP_3).*y4(HP2-3) + bT_3(NP_3).*y3(HP2-3) + cT_3(NP_3).*y2(HP2-3) + dT_3(NP_3).*y1(HP2-3) + eT_3(NP_3).*y(HP2-3));
T_2 = -Material_E.*(aT_2(1).*y4(HP2+4) + bT_2(1).*y3(HP2+4) + cT_2(1).*y2(HP2+4) + dT_2(1).*y1(HP2+4) + eT_2(1).*y(HP2+4));

Equal_T_32 = T_3_dx-T_2;

N_1 = R_s_1(NP_1).*Pn_1(NP_1) - R_s_1(NP_1).*Material_E.*(aN_1(NP_1).*y5(NP_1+3) + bN_1(NP_1).*y4(NP_1+3) + cN_1(NP_1).*y3(NP_1+3) + dN_1(NP_1).*y2(NP_1+3) + eN_1(NP_1).*y1(NP_1+3) + fN_1(NP_1).*y(NP_1+3));
N_3_sx = R_s_3(1).*Pn_3(1) - R_s_3(1).*Material_E.*(aN_3(1).*y5(HP1+4) + bN_3(1).*y4(HP1+4) + cN_3(1).*y3(HP1+4) + dN_3(1).*y2(HP1+4) + eN_3(1).*y1(HP1+4) + fN_3(1).*y(HP1+4));

Equal_N_13 = N_1 -N_3_sx;

N_3_dx = R_s_3(NP_3).*Pn_3(NP_3) - R_s_3(NP_3).*Material_E.*(aN_3(NP_3).*y5(HP2-3) + bN_3(NP_3).*y4(HP2-3) + cN_3(NP_3).*y3(HP2-3) + dN_3(NP_3).*y2(HP2-3) + eN_3(NP_3).*y1(HP2-3) + fN_3(NP_3).*y(HP2-3));
N_2 = R_s_2(1).*Pn_2(1) - R_s_2(1).*Material_E.*(aN_2(1).*y5(HP2+4) + bN_2(1).*y4(HP2+4) + cN_2(1).*y3(HP2+4) + dN_2(1).*y2(HP2+4) + eN_2(1).*y1(HP2+4) + fN_2(1).*y(HP2+4));

Equal_N_32 = N_3_dx - N_2;

% %% Caso 9
% bc_left = [y(4) y1(4) y2(4)];
% bc_right = [y(HP3-3) y1(HP3-3) y2(HP3-3)];
% Equal_u_13 = y(NP_1+3) - y(HP1+4);
% Equal_v_13 = -y1(NP_1+3)*R_s_1(NP_1) + y1(HP1+4)*R_s_3(1);
% Equal_u_32 = y(HP2-3) - y(HP2+4);
% Equal_v_32 = -y1(HP2-3)*R_s_3(NP_3) + y1(HP2+4)*R_s_2(1);
Equal_phi_13 = (-(y2(NP_1+3).*R_s_1(NP_1) + y1(NP_1+3).*dR_s_1(NP_1) + y(NP_1+3)./R_s_1(NP_1))) - (-(y2(HP1+4).*R_s_3(1) + y1(HP1+4).*dR_s_3(1) + y(HP1+4)./R_s_3(1)));
Equal_phi_32 = (-(y2(HP2-3).*R_s_3(NP_3) + y1(HP2-3).*dR_s_3(NP_3) + y(HP2-3)./R_s_3(NP_3))) - (-(y2(HP2+4).*R_s_2(1) + y1(HP2+4).*dR_s_2(1) + y(HP2+4)./R_s_2(1)));


%% Equations to solve
 equ_1 = a_1(1:NP_1).*y6(4:NP_1+3)+b_1(1:NP_1).*y5(4:NP_1+3)+c_1(1:NP_1).*y4(4:NP_1+3)+d_1(1:NP_1).*y3(4:NP_1+3)+e_1(1:NP_1).*y2(4:NP_1+3)+f_1(1:NP_1).*y1(4:NP_1+3)+g_1(1:NP_1).*y(4:NP_1+3)+h_1(1:NP_1);
 equ_3 = a_3(1:NP_3).*y6(HP1+4:HP2-3)+b_3(1:NP_3).*y5(HP1+4:HP2-3)+c_3(1:NP_3).*y4(HP1+4:HP2-3)+d_3(1:NP_3).*y3(HP1+4:HP2-3)+e_3(1:NP_3).*y2(HP1+4:HP2-3)+f_3(1:NP_3).*y1(HP1+4:HP2-3)+g_3(1:NP_3).*y(HP1+4:HP2-3)+h_3(1:NP_3);
 equ_2 = a_2(1:NP_2).*y6(HP2+4:HP2+3+NP_2)+b_2(1:NP_2).*y5(HP2+4:HP2+3+NP_2)+c_2(1:NP_2).*y4(HP2+4:HP2+3+NP_2)+d_2(1:NP_2).*y3(HP2+4:HP2+3+NP_2)+e_2(1:NP_2).*y2(HP2+4:HP2+3+NP_2)+f_2(1:NP_2).*y1(HP2+4:HP2+3+NP_2)+g_2(1:NP_2).*y(HP2+4:HP2+3+NP_2)+h_2(1:NP_2);
 
solver_v4hingebis = [equ_1 equ_2 equ_3 bc_left bc_right...
    Equal_u_13 Equal_v_13 Equal_u_32 Equal_v_32 Equal_T_13 Equal_N_13 Equal_T_32 Equal_N_32...
    M_elhinge_sx M_elhinge_dx M_elhinge_1 M_elhinge_2 M_elhinge_3_sx M_elhinge_3_dx];
%% Solver caso 9 

% solver_v4hingebis = [equ_1 equ_2 equ_3 bc_left bc_right...
%     Equal_u_13 Equal_v_13 Equal_u_32 Equal_v_32 Equal_phi_13 Equal_phi_32 Equal_M_13 Equal_M_32 Equal_T_13 Equal_N_13 Equal_T_32 Equal_N_32];

%% Caso sole molle alla base
% solver_v4hingebis = [equ_1 equ_2 equ_3 bc_left bc_right...
%     Equal_u_13 Equal_v_13 Equal_u_32 Equal_v_32 Equal_T_13 Equal_N_13 Equal_T_32 Equal_N_32...
%     M_elhinge_sx M_elhinge_dx Equal_phi_32 Equal_phi_13 Equal_M_13 Equal_M_32];
